/********************************************************

   vEdge

 ********************************************************/

class vEdge
{
   public final static int NOT_EQUAL = 0;
   public final static int EQUAL = 1;
   public final static int INVERSE = 2;

   public static int width, height;
   public static int[] videoBuffer = null;

   vVertex p1;
   vVertex p2;

   int   x0, y0;
   int   dy, dx;
   int   ady, adx;

   public static int worldTimeStamp = 0;

   private float angle;
   int timeStamp = 0;

   public vEdge( vVertex np1, vVertex np2 )
   {
      p1 = np1;
      p2 = np2;
   }

/********************************************************

   int isEqual()

   in: verratava edge tai sen vertexit
   out: ovatko edget samoja tai knteisi tai tysin eri... (heh)

 ********************************************************/

   public int isEqual( vEdge cmpto )
   {
      return isEqual( cmpto.p1, cmpto.p2 );
   }

   public int isEqual( vVertex np1, vVertex np2 )
   {
      if ((p1 == np1) && (p2 == np2)) return EQUAL;
      if ((p2 == np1) && (p1 == np2)) return INVERSE;
      return NOT_EQUAL;
   }

/********************************************************

   float getAngle( int )

   in:   timeStamp
   out:  laskee edgen kulmakertoimen

 ********************************************************/

   public final float getAngle( int now )
   {
      worldTimeStamp = now;  // worldTimeStamp = now; ???
      return getAngle();
   }

   public final float getAngle()
   {
      if (timeStamp == worldTimeStamp) return angle;

      timeStamp = worldTimeStamp;

      x0 = p1.px;
      y0 = p1.py;
      dx = p2.px - x0;
      dy = p2.py - y0;

      ady = (dy<0) ? -dy : dy;
      adx = (dx<0) ? -dx : dx;

      if (dy==0) angle = 0.0F;

      angle = (float) (1.0F * dx / dy);
      return angle;
   }

/********************************************************

   void prepareTexture()

   in:   -
   out:  laskee edge seuraavan tekstuurin adderin

 ********************************************************/

   int tTimeStamp = 0;

   float txAdder;
   float tyAdder;

   public final void prepareTexture()
   {
      if (tTimeStamp == worldTimeStamp) return;

      tTimeStamp = worldTimeStamp;

      float k = getAngle();
      txAdder = k * (p2.tx - p1.tx);
      tyAdder = k * (p2.ty - p1.ty);
   }

   int gTimeStamp = 0;

   float gAdder;

   public final void prepareGouraud()
   {
      if (gTimeStamp == worldTimeStamp) return;

      gTimeStamp = worldTimeStamp;

      if (dy == 0) return;

      gAdder = getAngle() * (p2.brightness - p1.brightness);
   }

   public final void prepareGouraudTexture()
   {
      if (gTimeStamp == worldTimeStamp)
      {
         prepareTexture();
         return;
      }
      if (tTimeStamp == worldTimeStamp)
      {
         prepareGouraud();
         return;
      }

      gTimeStamp = tTimeStamp = worldTimeStamp;

// prepareGouraud & prepareTexture  ... optimoi kivaksi

      prepareGouraud();
      prepareTexture();
   }

   public final void drawEdge( int now )
   {
      worldTimeStamp = now;
      drawEdge();
   }

/********************************************************

   void clipEdge()

   in:   -
   out:  -

 ********************************************************/

   int cTimeStamp = 0;

   public final void clipEdge()
   {
// laskee uuden dx:n, dy:n, x0:n ja y0:n
      if (dTimeStamp == worldTimeStamp) return;
      if (cTimeStamp == worldTimeStamp) return;

      cTimeStamp = worldTimeStamp;

      int x1 = p2.px;
      int y1 = p2.py;

      x0 = p1.px;
      y0 = p1.py;
      dx = x1 - x0;
      dy = y1 - y0;

      if (timeStamp != worldTimeStamp)
      {
         timeStamp = worldTimeStamp;

         if (dy==0) angle = 0.0F;

         angle = (float) (1.0F * dx / dy);
      }

      if (x0 < 0)
      {
         if (x1 < 0)
         {
            dTimeStamp = worldTimeStamp;
            return;
         }

         float temp = 1.0F * dy / dx;
         y0 -= temp * x0;
         x0 = 0;
         dy = y1 - y0;
         dx = x1 - x0;
      }
      else
      if (x1 < 0)
      {

         float temp = 1.0F * dy / dx;
         y1 -= temp * x1;
         x1 = 0;
         dy = y1 - y0;
         dx = x1 - x0;

      }

      if (x0 >= width)
      {
         if (x1 >= width)
         {
            dTimeStamp = worldTimeStamp;
            return;
         }

         float temp = 1.0F * dy / dx;
         y0 -= temp * (x0 - width + 1);
         x0 = width - 1;
         dy = y1 - y0;
         dx = x1 - x0;
      }
      else
      if (x1 >= width)
      {
         float temp = 1.0F * dy / dx;
         y1 -= temp * (x1 - width + 1);
         x1 = width - 1;
         dy = y1 - y0;
         dx = x1 - x0;
      }

      if (y0 < 0)
      {
         if (y1 < 0)
         {
            dTimeStamp = worldTimeStamp;
            return;
         }

         x0 -= angle * y0;
         y0 = 0;
         dx = x1 - x0;
         dy = y1 - y0;
      }
      else
      if (y1 < 0)
      {
         x1 -= angle * y1;
         y1 = 0;
         dx = x1 - x0;
         dy = y1 - y0;
      }

      if (y0 >= height)
      {
         if (y1 >= height)
         {
            dTimeStamp = worldTimeStamp;
            return;
         }

         x0 -= angle * (y0 - height + 1);
         y0 = height - 1;
         dy = y1 - y0;
         dx = x1 - x0;
      }
      else
      if (y1 >= height)
      {
         x1 -= angle * (y1 - height + 1);
         y1 = height - 1;
         dy = y1 - y0;
         dx = x1 - x0;
      }

      ady = (dy<0) ? -dy : dy;
      adx = (dx<0) ? -dx : dx;
   }

   public final void drawClipEdge()
   {
      clipEdge();
      drawEdge();
   }

   int dTimeStamp = 0;
   public static float c = 2.0F;
   int color = 0xffcccc99;       //0xffffffff;
   int rb0 = 0x00cc0099;
   int g0 = 0x0000cc00;
   int rb1 = 0;
   int g1 = 0;

   public final void drawEdge()
   {
//      System.out.println("trying edge at "+this);
      if (dTimeStamp == worldTimeStamp)
      {
//         System.out.println("(again)");
         return;
      }

      dTimeStamp = worldTimeStamp;

      float k = getAngle();

      if ((dy == 0) && (dx == 0))
      {
//         System.out.println("null vector; edge " + this);
         return;
      }

   try {

      if (ady>adx)
      {
// jyrkk viiva
         float l = (float) (c * Math.sqrt( (dx*dx+dy*dy) ) / (float) ady);

         int yoffs = y0 * width;
         float xoffs = x0 - l / 2.0F;

         int yadd;
         float xadd;

         if (dy<0)
         {
            yadd = -width;
            xadd = -k;
         }
         else
         {
            yadd = width;
            xadd = k;
         }
/*
         videoBuffer[yoffs+x0] = 0xffffffff;
         videoBuffer[yoffs+x0+dy*width+dx] = 0xffffffff;
*/
         if (l > 1.0F)
         {
            for(int y = 0;y<ady;y++)
            {
               float endoffs = xoffs + l;

               for(int i=(int) (xoffs+1);i<(int) endoffs;i++)
               {
                  videoBuffer[yoffs+i] += 255;
//                  videoBuffer[yoffs+i] = color;
               }
/*
               int temp = videoBuffer[yoffs+(int) xoffs];
               int rb1 = temp & 0x00ff00ff;
               int g1 = temp & 0x0000ff00;
*/
               int m = ((int) (xoffs * 256.0F)) & 255;
/*
               videoBuffer[yoffs+(int) xoffs] =
                                  ((((rb0 * (255-m)) >> 8) & 0x00ff00ff) +
                                   (((g0 * (255-m)) >> 8) & 0x0000ff00) +
                                   (((rb1 * m) >> 8) & 0x00ff00ff) +
                                   (((g1 * m) >> 8) & 0x0000ff00)) |
                                   0xff000000;
*/
               videoBuffer[yoffs+(int) xoffs] += (255-m);

               m = ((int) (endoffs * 256.0F)) & 255;

               if (m>0) {

                  videoBuffer[yoffs+(int) endoffs] += m;
/*
                  temp = videoBuffer[yoffs+(int) endoffs];
                  rb1 = temp & 0x00ff00ff;
                  g1 = temp & 0x0000ff00;

                  videoBuffer[yoffs+(int) endoffs] =
                                  ((((rb0 * m) >> 8) & 0x00ff00ff) +
                                   (((g0 * m) >> 8) & 0x0000ff00) +
                                   (((rb1 * (255-m)) >> 8) & 0x00ff00ff) +
                                   (((g1 * (255-m)) >> 8) & 0x0000ff00)) |
                                   0xff000000;
*/
               }

               xoffs += xadd;
               yoffs += yadd;
            }
         }
         else
         {
            System.out.println(" ylempi kusee: c = " + c + " dx = " + dx + " dy = " + dy + " l = " + l);
         }
      }
      else
      {
// loiva viiva
         float l = (float) (c * Math.sqrt( (dx*dx+dy*dy) ) / (float) adx);

// opt!!!
         float yadd = (1.0F * dy / dx);

         float yoffs = y0 - l/2.0F;
         int xoffs = x0;

         int xadd = (dx<0) ? -1 : 1;


         if (dx<0)
         {
            yadd = -yadd;
            xadd = -1;
         }
         else
         {
            xadd = 1;
         }


         if (l > 1.0F)
         {
            for(int x = 0;x<adx;x++)
            {
               float endoffs = yoffs + l;

               int offs = xoffs + ((int) yoffs) * width;
/*
               int temp = videoBuffer[offs];
               int rb1 = temp & 0x00ff00ff;
               int g1 = temp & 0x0000ff00;
*/
               int m = ((int) (yoffs * 256.0F)) & 255;
/*
               videoBuffer[offs] =((((rb0 * (255-m)) >> 8) & 0x00ff00ff) +
                                   (((g0 * (255-m)) >> 8) & 0x0000ff00) +
                                   (((rb1 * m) >> 8) & 0x00ff00ff) +
                                   (((g1 * m) >> 8) & 0x0000ff00)) |
                                   0xff000000;
*/
               videoBuffer[offs] += (255-m);

               for(int i=(int) (yoffs+1);i<(int) endoffs;i++)
               {
                  offs += width;
//                  videoBuffer[offs] = color;
                  videoBuffer[offs] += 255;
               }

               m = ((int) (endoffs * 256.0F)) & 255;

               if (m>0) {
                  offs += width;
/*
                  temp = videoBuffer[offs];
                  rb1 = temp & 0x00ff00ff;
                  g1 = temp & 0x0000ff00;

                  videoBuffer[offs] =
                                  ((((rb0 * m) >> 8) & 0x00ff00ff) +
                                   (((g0 * m) >> 8) & 0x0000ff00) +
                                   (((rb1 * (255-m)) >> 8) & 0x00ff00ff) +
                                   (((g1 * (255-m)) >> 8) & 0x0000ff00)) |
                                   0xff000000;
*/
                  videoBuffer[offs] += m;
               }

               xoffs += xadd;
               yoffs += yadd;
            }
         }
         else
         {
            System.out.println(" alempi kusee: c = " + c + " dx = " + dx + " dy = " + dy + " l = " + l);
         }
      }
   } catch(ArrayIndexOutOfBoundsException e)
   {
// kludge ratkaisu, mutta mits siit kun on nopeat koneet
   }

   }
}