/********************************************************

   vVertex

 ********************************************************/



public class vVertex extends vMatrix
{

   public final static float dConst = 256.0F;

   public static int width, height;
   public static int width2, height2;

   private static float wx, wy, wz;
   public static float r00, r01, r02;
   public static float r10, r11, r12;
   public static float r20, r21, r22;

   public static float d0, d1, d2;

   public static vObject currentObject = null;
   public static int now = 0; //

   public float x, y, z;            // pisteen x,y ja z koordinaatit
   private float xy;                // x * y
   public float rx, ry, rz;         // pisteen pyritetyt koordinaatit
   private float pz;                // d / rz
   public int px, py;               // projisoidut koordinaatit

   float tx, ty;                    // tekstuurikoordinaatit
   float bx, by;                    // bump-koordinaatit
   float ex, ey;                    // environmentkoordinaatit (lasketaan!)

   public static float lx, ly, lz;  // valonlhteen normalisoitu paikka
                                    // suhteessa obuun (tai tasoon)

   public int brightness = 0;

   vVertex  nextVertex = null;
   vVertex  nextActiveVertex = null;

   vNormal  vertexNormal = null;    // pisteen normaali
                                    // (= viereisten tasonormaalien ka)

   public int rTimeStamp = 0;
   public int pTimeStamp = 0;

/********************************************************


 ********************************************************/

   public vVertex( vVertex vertexList, float nx, float ny, float nz, int ntx, int nty, int nbx, int nby )
   {

//      if (verbose) System.out.println("New vertex at ("+nx+", "+ny+", "+nz")");

      x = nx;
      y = ny;
      z = nz;

      xy = x * y;

      tx = ntx;
      ty = nty;

      bx = nbx;
      by = nby;

      vertexNormal = new vNormal( 0, 0, 0 );  // luodaan dummy-normaali
   }

/********************************************************


 ********************************************************/

   public final vVertex add( vVertex newVertex )
   {
      return this;
   }

/********************************************************

   setObject()

 ********************************************************/

   public static final void setObject( vObject object )
   {
      if ((currentObject == object) &&
          (now == currentObject.timeStamp)) return;

//      System.out.println("vVertex object now " + currentObject);

      currentObject = object;

      now = object.timeStamp;

      wx = currentObject.rx;
      wy = currentObject.ry;
      wz = currentObject.rz;

//      currentObject.orientation.copyMatrix( this );

      r00 = currentObject.r00;
      r01 = currentObject.r01;
      r02 = currentObject.r02;

      r10 = currentObject.r10;
      r11 = currentObject.r11;
      r12 = currentObject.r12;

      r20 = currentObject.r20;
      r21 = currentObject.r21;
      r22 = currentObject.r22;

/*
      System.out.println("rotation matrix:");
      System.out.println( (int) (1000*r00) + " " +
                          (int) (1000*r01) + " " +
                          (int) (1000*r02) + " ");
      System.out.println( (int) (1000*r10) + " " +
                          (int) (1000*r11) + " " +
                          (int) (1000*r12) + " ");
      System.out.println( (int) (1000*r20) + " " +
                          (int) (1000*r21) + " " +
                          (int) (1000*r22) + " ");
*/

      d0 = r00 * r01;
      d1 = r10 * r11;
      d2 = r20 * r21;
   }

/********************************************************

   void prepareGouraud()

 ********************************************************/

   int gTimeStamp = 0;

   public final void prepareGouraud()
   {
      if (gTimeStamp == now) return;

      gTimeStamp = now;

      float tempx = x + lx;
      float tempy = y + ly;
      float tempz = z + lz;

      float nx = vertexNormal.x;
      float ny = vertexNormal.y;
      float nz = vertexNormal.z;

      brightness = (int) (tempx * nx + tempy * ny + tempz * nz);
   }

/********************************************************


 ********************************************************/

   int eTimeStamp = 0;

   public final void preparePhong()
   {
      if (eTimeStamp == now) return;

      eTimeStamp = now;

      float nx = vertexNormal.x;
      float ny = vertexNormal.y;
      float nz = vertexNormal.z;

      ex = 128 + ((r00 * nx) + (r01 * ny) + (r02 * nz));
      ey = 128 + ((r10 * nx) + (r11 * ny) + (r12 * nz));
   }

/********************************************************


 ********************************************************/

   public final void rotate()
   {
      if (rTimeStamp == now) return;

      rx = (r01 + x) * (r00 + y) - d0 - xy + r02 * z + wx;
      ry = (r11 + x) * (r10 + y) - d1 - xy + r12 * z + wy;
      rz = (r21 + x) * (r20 + y) - d2 - xy + r22 * z + wz;

      rTimeStamp = now;
   }

   public final void project()
   {
      if (pTimeStamp == now) return;

      pz = dConst / rz;
      px = (int) (rx * pz) + width2;
      py = (int) (ry * pz) + height2;

/*
      System.out.println("vertex:      ("+x+", "+y+", "+z+")");
      System.out.println("rotated to   ("+rx+", "+ry+", "+rz+")");
      System.out.println("projected to ("+px+", "+py+")");
      System.out.println();
*/
      pTimeStamp = now;
   }

   public final void rotateProject()
   {
      if (pTimeStamp == now) return;

      if (rTimeStamp != now)
      {
         rx = (r01 + x) * (r00 + y) - d0 - xy + r02 * z + wx;
         ry = (r11 + x) * (r10 + y) - d1 - xy + r12 * z + wy;
         rz = (r21 + x) * (r20 + y) - d2 - xy + r22 * z + wz;
         rTimeStamp = now;
      }

      pz = dConst / rz;
      px = (int) (rx * pz) + width2;
      py = (int) (ry * pz) + height2;

/*
      System.out.println("vertex:      ("+x+", "+y+", "+z+")");
      System.out.println("rotated to   ("+rx+", "+ry+", "+rz+")");
      System.out.println("projected to ("+px+", "+py+")");
      System.out.println();
*/
      pTimeStamp = now;
   }
}
